'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-bdeef4f4.js');
const defaultUiConfig = require('./default-ui-config-8a058612.js');
const defaultIconPack = require('./default-icon-pack-0ea0e986.js');
const index$1 = require('./index-dbc5b08f.js');
const index$2 = require('./index-7a96dd15.js');
require('./default-language-4c779255.js');

const dyteSpotlightGridCss = ":host{display:flex;height:100%;width:100%}main{flex:1 1 0%}aside{width:50%;max-width:var(--dyte-space-96, 384px)}:host([size='sm']),:host([size='md']){flex-direction:column}:host([size='sm']) aside,:host([size='md']) aside{height:50%;max-height:var(--dyte-space-96, 384px);width:100%;max-width:100%}";

const DyteSpotlightGrid = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /** Participants */
    this.participants = [];
    /** Pinned Participants */
    this.pinnedParticipants = [];
    /**
     * Aspect Ratio of participant tile
     *
     * Format: `width:height`
     */
    this.aspectRatio = '16:9';
    /** Gap between participant tiles */
    this.gap = 8;
    /** UI Config */
    this.config = defaultUiConfig.defaultConfig;
    /** Icon Pack */
    this.iconPack = defaultIconPack.defaultIconPack;
    /** Language */
    this.t = index$1.useLanguage();
  }
  render() {
    const defaults = {
      meeting: this.meeting,
      config: this.config,
      states: this.states,
      size: this.size,
      iconPack: this.iconPack,
      t: this.t,
    };
    const nonPinnedParticipants = this.participants.filter((p) => !this.pinnedParticipants.includes(p));
    return (index.h(index.Host, null, index.h("main", null, index.h(index$2.Render, { element: "dyte-simple-grid", defaults: defaults, props: {
        participants: this.pinnedParticipants,
        aspectRatio: this.aspectRatio,
        gap: this.gap,
        size: 'md',
      } })), index.h("aside", null, index.h(index$2.Render, { element: "dyte-simple-grid", defaults: defaults, props: {
        participants: nonPinnedParticipants,
        aspectRatio: this.aspectRatio,
        gap: this.gap,
        size: 'sm',
      } }))));
  }
  get host() { return index.getElement(this); }
};
DyteSpotlightGrid.style = dyteSpotlightGridCss;

exports.dyte_spotlight_grid = DyteSpotlightGrid;
