'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const config = require('./config-6e62381d.js');
const defaultUiConfig = require('./default-ui-config-8a058612.js');
const defaultIconPack = require('./default-icon-pack-0ea0e986.js');
const defaultLanguage = require('./default-language-4c779255.js');

/**
 * Send notification which will be displayed in the `<dyte-notifications />` component.
 * @param notification Notification object
 * @returns Return value of emitting the event
 */
const sendNotification = (notification) => {
  if (typeof document === 'undefined')
    return false;
  const event = new CustomEvent('dyteNotification', {
    detail: notification,
    composed: true,
  });
  return document.dispatchEvent(event);
};

exports.extendConfig = config.extendConfig;
exports.generateConfig = config.generateConfig;
exports.provideDyteDesignSystem = config.provideDyteDesignSystem;
exports.defaultConfig = defaultUiConfig.defaultConfig;
exports.defaultIconPack = defaultIconPack.defaultIconPack;
exports.defaultLanguage = defaultLanguage.defaultLanguage;
exports.sendNotification = sendNotification;
