export { e as extendConfig, g as generateConfig, p as provideDyteDesignSystem } from './config-4902b022.js';
export { d as defaultConfig } from './default-ui-config-c5d610a7.js';
export { d as defaultIconPack } from './default-icon-pack-eabba256.js';
export { d as defaultLanguage } from './default-language-04851639.js';

/**
 * Send notification which will be displayed in the `<dyte-notifications />` component.
 * @param notification Notification object
 * @returns Return value of emitting the event
 */
const sendNotification = (notification) => {
  if (typeof document === 'undefined')
    return false;
  const event = new CustomEvent('dyteNotification', {
    detail: notification,
    composed: true,
  });
  return document.dispatchEvent(event);
};

export { sendNotification };
