import { Size } from '../../types/props';
export declare type ButtonVariant = 'primary' | 'secondary' | 'danger' | 'ghost';
export declare type ButtonKind = 'button' | 'icon' | 'wide';
/**
 * A button that follows Dyte's Design System.
 *
 * @slot - Default slot
 * @slot start - Content placed to the start of the button, i.e; left.
 * @slot end - Content placed to the end of the button, i.e; right.
 */
export declare class DyteButton {
  /** Size */
  size: Size;
  /** Button variant */
  variant: ButtonVariant;
  /** Button type */
  kind: ButtonKind;
  /** Whether to reverse order of children */
  reverse: boolean;
  /** Where the button is disabled or not */
  disabled: boolean;
  render(): any;
}
