import { Meeting } from '../../types/dyte-client';
import { Size, Notification, States } from '../../types/props';
import { IconPack } from '../../lib/icons';
import { UIConfig } from '../../types/ui-config';
/**
 * A component which handles notifications.
 *
 * You can configure which notifications you want to see and which ones you want to hear.
 * There are also certain limits which you can set as well.
 */
export declare class DyteNotifications {
  private audio;
  private notificationPermissions;
  private soundPermissions;
  private participantJoinedSoundNotificationLimit;
  private participantChatMessageSoundNotificationLimit;
  private participantJoinedListener;
  private participantLeftListener;
  private chatUpdateListener;
  private pollUpdateListener;
  private deviceUpdateListener;
  private networkUpdateListener;
  private disconnectTimeout;
  host: HTMLDyteNotificationsElement;
  /** Meeting object */
  meeting: Meeting;
  /** States object */
  states: States;
  /** Config object */
  config: UIConfig;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  /** Size */
  size: Size;
  /** Icon pack */
  iconPack: IconPack;
  notifications: Notification[];
  connectedCallback(): void;
  disconnectedCallback(): void;
  meetingChanged(meeting: Meeting): void;
  configChanged(config: UIConfig): void;
  statesUpdate(states: States): void;
  private onRemoteUpdate;
  private onDyteNotification;
  private add;
  private remove;
  private handleDismiss;
  private canPlayParticipantJoinedSound;
  private canPlayChatSound;
  render(): any;
}
