import { IconPack } from '../../lib/icons';
import { Meeting, Peer } from '../../types/dyte-client';
import { Size, States } from '../../types/props';
import { UIConfig } from '../../types/ui-config';
import { Dimensions } from '../../lib/grid';
/**
 * A grid component which renders only the participants in a simple grid.
 */
export declare class DyteSimpleGrid {
  private resizeObserver;
  /** Participants */
  participants: Peer[];
  /**
   * Aspect Ratio of participant tile
   *
   * Format: `width:height`
   */
  aspectRatio: string;
  /** Gap between participant tiles */
  gap: number;
  /** Size */
  size: Size;
  /** Meeting object */
  meeting: Meeting;
  /** States object */
  states: States;
  /** UI Config */
  config: UIConfig;
  /** Icon Pack */
  iconPack: IconPack;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  dimensions: Dimensions;
  host: HTMLDyteSimpleGridElement;
  private setHostDimensions;
  connectedCallback(): void;
  disconnectedCallback(): void;
  render(): any;
}
